import sys
sys.path.append("..")
from CalculatingFeatures.helper_functions import convert1DEmpaticaToArray, convertInputInto2d, frequencyFeatureNames, hrvFeatureNames
from CalculatingFeatures.calculate_features import calculateFeatures
import pandas as pd



pathToHrvCsv = "../example_data/S2_E4_Data/BVP.csv"
windowLength = 500

# get an array of values from HRV empatica file
hrv_data, startTimeStamp, sampleRate = convert1DEmpaticaToArray(pathToHrvCsv)
hrv_data = hrv_data[:int(300000//sampleRate)]

# Convert the HRV data into 2D array
hrv_data_2D = convertInputInto2d(hrv_data, windowLength)

# Create a list with feature names
featureNames = []
featureNames.extend(hrvFeatureNames)
featureNames.extend(frequencyFeatureNames)

pd.set_option('display.max_columns', None)

# Calculate features
calculatedFeatures = calculateFeatures(hrv_data_2D, fs=int(sampleRate), featureNames=featureNames)
print(calculatedFeatures)
